Comment *---------------------------+
|                                   |
|          Fractal Dragon           |
|                                   |
+-----------------------------------*
.586
.Model Flat, StdCall
Option CaseMap: None

RepArg Macro Arg
  Local NewStr
    Quot SubStr <Arg>, 1, 1
  IfIdn Quot, <">
    .Data
      NewStr db Arg,0
    .Code
    ExitM <ADDR NewStr>
  Else
    ExitM <Arg>
  EndIf
EndM

@ Macro Function:Req, Args:VarArg
  Arg equ <Invoke Function>
  For Var, <Args>
    Arg CatStr Arg, <, RepArg(Var)>
  EndM
  Arg
  ExitM <eax>
EndM

Public @Main

; Event Constants
REDRAW_EVENT      = 1
KEY_EVENT         = 2
BUTTON_EVENT      = 3

; Window Style Constants
WS_SKINNED_SIZABLE =  3000000H
WS_COORD_CLIENT    = 20000000H
WS_CAPTION         = 10000000H

; Caption Style Constants
CS_MOVABLE        = 0

; Event Mask Constants
EM_REDRAW         = 1
EM_KEY            = 2
EM_BUTTON         = 4

; Button identifiesrs
BUTTON_CLOSE      = 1

WINDOW_BORDER_SIZE = 5

TButtonInput Struct
  MouseButton Byte ?
  ID          Word ?
  HiID        Byte ?
TButtonInput EndS

TSize Struct
  SizeY Word ?
  SizeX Word ?
TSize EndS

TBox Struct
  X     SDword ?
  Y     SDword ?
  SizeX Dword ?
  SizeY Dword ?
TBox EndS

TThreadInfo Struct
  CpuUsage     Dword ?
  WinStackPos  Word ?
  reserved0    Word ?
  reserved1    Word ?
  ThreadName   Byte 11 Dup (?)
  reserved2    Byte ?
  MemAddress   Dword ?
  MemUsage     Dword ?
  Identifier   Dword ?
  Window       TBox <>
  ThreadState  Word ?
  reserved3    Word ?
  Client       TBox <>
  WindowState  Byte ?
  EventMask    Dword ?
  KeyboardMode Byte ?
  reserved4    Byte 948 Dup (?)
TThreadInfo EndS

GetButton       Proto
GetKey          Proto
WaitEvent       Proto
BeginDraw       Proto
EndDraw         Proto
GetScreenSize   Proto
GetSkinHeight   Proto
GetThreadInfo   Proto Slot:Dword, Buffer: Ptr TThreadInfo
DrawWindow      Proto Left:SDword, Top:SDword, Right:SDword, Bottom:SDword, Caption:Ptr, BackColor:Dword, Style:Dword, CapStyle:Dword
DrawLine        Proto X1:SDword, Y1:SDword, X2:SDword, Y2:SDword, Color:Dword
ThreadTerminate Proto

.Const
szCaption db "Fractal Dragon",0
Float_2   Real4 2.0
Float_3_8 Real4 3.8
Float_2_5 Real4 2.5
Float_1_2 Real4 1.2
Float_1_3 Real4 1.3

.Data?
Button TButtonInput <>
Screen TSize <>
Window TBox <>
ThreadInfo TThreadInfo <>
SX Dword ?
SY Dword ?
DragonSize Dword ?
T Dword ?
K Dword ?
TT Dword ?
KK Dword ?

.Code
RGB Proc R:Dword, G:Dword, B:Dword
  xor eax, eax
  mov al, Byte Ptr [R]
  shl eax, 16
  mov al, Byte Ptr [B]
  mov ah, Byte Ptr [G]
  ret
RGB EndP
;*******************************************************************************
DoDraw Proc Uses ebx esi edi X1:Real4, Y1:Real4, X2:Real4, Y2:Real4, Depth:Dword
Local Xn:Real4, Yn:Real4

  .If Depth > 0
    fld X2       ;
    fadd X1      ;
    fdiv Float_2 ;
    fld Y2       ;
    fsub Y1      ; Xn = (X1 + X2) / 2 + (Y2 - Y1) / 2
    fdiv Float_2 ;
    fxch st(1)   ;
    faddp        ;
    fstp Xn      ;

    fld Y2       ;
    fadd Y1      ;
    fdiv Float_2 ;
    fld X2       ;
    fsub X1      ; Yn = (Y1 + Y2) / 2 - (X2 - X1) / 2
    fdiv Float_2 ;
    fxch st(1)   ;
    fsubrp       ;
    fstp Yn      ;

    mov ebx, Depth
    dec ebx

    Invoke DoDraw, X1, Y1, Xn, Yn, ebx
    Invoke DoDraw, X2, Y2, Xn, Yn, ebx
  .Else
    inc T
    .If T > 255 * (1 SHL 7)
      mov T, 0
      inc K
      .If K > 2
        mov K, 0
        inc TT
        .If TT > 255 * (1 SHL 7)
          mov TT, 0
          inc KK
          .If KK > 2
            mov KK, 0
          .EndIF
        .EndIf
      .EndIf
    .EndIf

    mov eax, TT
    shr eax, 7
    neg eax
    add eax, 255
    mov ebx, T
    shr ebx, 7
    mov ecx, 255
    sub ecx, ebx

    .If K == 0
      Invoke RGB, eax, ecx, ebx
    .ElseIf K == 1
      Invoke RGB, ecx, eax, ebx
    .Else
      Invoke RGB, ecx, ebx, eax
    .EndIf

    fld Y2
    fistp Y2
    fld X2
    fistp X2
    fld Y1
    fistp Y1
    fld X1
    fistp X1

    Invoke DrawLine, X1, Y1, X2, Y2, eax
  .EndIf
  ret
DoDraw EndP
;*******************************************************************************
DrawDragon Proc Uses esi edi
Local Depth:Dword, X1:Real4, Y1:Real4, X2:Real4, Y2:Real4

  Invoke GetThreadInfo, 0FFFFFFFFH, Offset ThreadInfo

  mov esi, ThreadInfo.Window.SizeX
  mov edi, ThreadInfo.Window.SizeY
  sub esi, WINDOW_BORDER_SIZE * 2
  sub edi, WINDOW_BORDER_SIZE
  sub edi, @(GetSkinHeight)
  mov SX, esi
  mov SY, edi
  .If esi < edi
    fild SX
  .Else
    fild SY
  .EndIf
  fistp DragonSize

  fild DragonSize
  fdiv Float_3_8
  fstp X1

  fild DragonSize
  fdiv Float_2_5
  fstp Y1

  fild DragonSize
  fdiv Float_1_2
  fstp X2

  fild DragonSize
  fdiv Float_1_3
  fstp Y2

  fild DragonSize
  sub esp, 4
  fistp dword ptr [esp]
  pop eax
  bsr eax, eax
  shl eax, 1
  inc eax
  mov Depth, eax

  invoke DoDraw, X1, Y1, X2, Y2, Depth
  ret
DrawDragon EndP
;*******************************************************************************
@Main:
  mov Screen, @(GetScreenSize)
  movzx eax, Screen.SizeX
  movzx ecx, Screen.SizeY
  shr eax, 3
  shr ecx, 3
  imul eax, 5
  imul ecx, 5
  mov Window.SizeX, eax
  mov Window.SizeY, ecx
  movzx eax, Screen.SizeX
  movzx ecx, Screen.SizeY
  sub eax, Window.SizeX
  sub ecx, Window.SizeY
  shr eax, 1
  shr ecx, 1
  mov Window.X, eax
  mov Window.Y, ecx
  .Repeat
    Invoke WaitEvent
    .If eax == REDRAW_EVENT
      Invoke BeginDraw
      Invoke DrawWindow, Window.X, Window.Y, Window.SizeX, Window.SizeY, Offset szCaption, 0, WS_SKINNED_SIZABLE + WS_COORD_CLIENT + WS_CAPTION, CS_MOVABLE
      Invoke DrawDragon
      Invoke EndDraw
    .ElseIf eax == KEY_EVENT
      Invoke GetKey
    .ElseIf eax == BUTTON_EVENT
      mov Button, @(GetButton)
      .If Button.ID == BUTTON_CLOSE
        Invoke ThreadTerminate
      .EndIf
    .EndIf
  .Until 0
END